#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "HX711.h"
LiquidCrystal_I2C lcd(0x27,16,2);
HX711 scale;
#define clk 2
#define dt 3
#define sw 4
#define in1 7
#define in2 8
#define in3 9
#define in4 10
#define in5 11
#define in6 12
volatile boolean TurnDetected;
volatile boolean up;
bool doonce = 0;
char screen = 0;
boolean pumpstate = 0;

void isr0 ()  {
  TurnDetected = true;
  up = (digitalRead(clk) == digitalRead(dt));
}

void setup() {
  lcd.init();
  lcd.backlight();
  lcd.begin(16, 2);
  pinMode(sw, INPUT_PULLUP);
  pinMode(clk, INPUT);
  pinMode(dt, INPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(in5, OUTPUT);
  pinMode(in6, OUTPUT);
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  digitalWrite(in5, LOW);
  digitalWrite(in6, LOW);
  digitalWrite(in1, HIGH);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, HIGH);
  digitalWrite(in5, HIGH);
  digitalWrite(in6, HIGH);
  attachInterrupt (0, isr0, RISING);

}

void loop() {
  if (TurnDetected) {
    delay(200);
    if (pumpstate == 1) {
      TurnDetected = false;
    }
    else {
      doonce = 0;
      if (up) {
        screen++;
        if (screen > 2) {
          screen = 2;
        }
      }
      else {
        screen = screen - 1;
        if (screen < 0) {
          screen = 0;
        }
      }
      TurnDetected = false;
    }
  }

  if (digitalRead(sw) == LOW) {
    delay(200);
    pumpstate = !pumpstate;
    doonce = 0;
  }

  if (screen == 0 && doonce == 0) {
    lcd.clear();
    lcd.print("Vodka Soda");
    lcd.setCursor(0, 1);
    if (pumpstate == 0) {
      lcd.print("Dispense?");
      digitalWrite(in1, HIGH);
      digitalWrite(in3, HIGH);
    }
    if (pumpstate == 1) {
      lcd.print("Push to Continue");
      digitalWrite(in1,LOW);
      delay(5000);
      digitalWrite(in1, HIGH);
      digitalWrite(in3,LOW);
      delay(10000);
      digitalWrite(in3, HIGH);
    }
    doonce = 1;
  }

  if (screen == 1 && doonce == 0) {
    lcd.clear();
    lcd.print("Vodka Juice");
    lcd.setCursor(0, 1);
    if (pumpstate == 0) {
       lcd.print("Dispense?");
      digitalWrite(in1, HIGH);
      digitalWrite(in5, HIGH);
    }
    if (pumpstate == 1) {
      lcd.print("Push to Continue");
      digitalWrite(in1,LOW);
      delay(5000);
      digitalWrite(in1, HIGH);
      digitalWrite(in5,LOW);
      delay(10000);
      digitalWrite(in5, HIGH);
    }
    doonce = 1;
  }

  if (screen == 2 && doonce == 0) {
    lcd.clear();
    lcd.print("VodkaSodaJuice");
    lcd.setCursor(0, 1);
    if (pumpstate == 0) {
       lcd.print("Dispense?");
      digitalWrite(in1, HIGH);
      digitalWrite(in3, HIGH);
      digitalWrite(in5, HIGH);
    }
    if (pumpstate == 1) {
      lcd.print("Push to Continue");
      digitalWrite(in1,LOW);
      delay(5000);
      digitalWrite(in1, HIGH);
      digitalWrite(in3,LOW);
      delay(10000);
      digitalWrite(in3, HIGH);
      digitalWrite(in5,LOW);
      delay(10000);
      digitalWrite(in5, HIGH);
    }
    doonce = 1;
  }
}

void alloff() {
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  digitalWrite(in5, LOW);
  digitalWrite(in6, LOW);
}
